
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>hll 估值插件 在Greenplum中的使用 以及 分布式聚合函数优化思路 / iVAN</title>

    <meta name="description" content="hll 估值插件 在Greenplum中的使用 以及 分布式聚合函数优化思路 背景 在大数据分析中,通常会有一些估值的需求,例如估计某个时间段有多少新增用户,估计某个时间段有多少用户. 常用的估值算法如HyperLogLog,还有一些其他的估值算法. 可以参考http://www.pipelinedb.com/ 我在几年前写过如何在PostgreSQL中使用HLL,请参考https://github.com/aggregateknowledge/postgresql-hllhttp://blog.163.com/digoal@126/blog/static/1638770">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">hll 估值插件 在Greenplum中的使用 以及 分布式聚合函数优化思路</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>背景</h2>
<p>在大数据分析中，通常会有一些估值的需求，例如估计某个时间段有多少新增用户，估计某个时间段有多少用户。</p>
<p>常用的估值算法如HyperLogLog，还有一些其他的估值算法。</p>
<p>可以参考<br /><a href="http://www.pipelinedb.com/" rel="external nofollow noreferrer">http://www.pipelinedb.com/</a></p>
<p>我在几年前写过如何在PostgreSQL中使用HLL，请参考<br /><a href="https://github.com/aggregateknowledge/postgresql-hll" rel="external nofollow noreferrer">https://github.com/aggregateknowledge/postgresql-hll</a><br /><a href="http://blog.163.com/digoal@126/blog/static/16387704020131264480325/" rel="external nofollow noreferrer">http://blog.163.com/digoal@126/blog/static/16387704020131264480325/</a><br /><a href="http://blog.163.com/digoal@126/blog/static/1638770402013127917876/" rel="external nofollow noreferrer">http://blog.163.com/digoal@126/blog/static/1638770402013127917876/</a></p>
<p>这里要说的是在Greenplum中的使用。</p>
<p>Greenplum是个分布式数据库系统，特别需要注意的是它的聚合用法与单节点不一样。</p>
<p>我之前写过基于PostgreSQL的另一个分布式系统Postgres-XC的聚合函数的原理和写法，有兴趣的同学可以参考如下</p>
<p><a href="http://blog.163.com/digoal@126/blog/static/16387704020134222140958/" rel="external nofollow noreferrer">http://blog.163.com/digoal@126/blog/static/16387704020134222140958/</a></p>
<h2>Greenplum聚合函数原理简介</h2>
<p>其实Greenplum的聚合函数用法和postgres-xc及其的相似。</p>
<p>语法如下</p>
<pre><code>CREATE [ORDERED] AGGREGATE name (input_data_type [ , ... ])
( SFUNC = sfunc,
STYPE = state_data_type
[, PREFUNC = prefunc]
[, FINALFUNC = ffunc]
[, INITCOND = initial_condition]
[, SORTOP = sort_operator] )
</code></pre>
<p>有两种聚合运算模式可选<br />
1. 如果只配置了sfunc，则相关数据全部收集到master节点，在master节点对所有数据依条加上sfunc的结果(第一次可选为initcond)输入给sfunc计算，直到所有数据都跑完sfunc，最后如果设置了finalfunc，则计算并得到最终结果。</p>
<p>2. 如果同时配置了sfunc和prefunc，则在segment节点并行完成sfunc，然后将segment节点执行的结果发给master，在master调用prefunc进行再次聚合，输出结果，如果配置了finalfunc，则这个结果再给finalfunc执行并输出最终结果。</p>
<p>过程如下 :</p>
<pre><code>sfunc( internal-state, next-data-values ) ---&gt; next-internal-state
prefunc( internal-state, internal-state ) ---&gt; next-internal-state
ffunc( internal-state ) ---&gt; aggregate-value
</code></pre>
<h2>在Greenplum上编译安装hll</h2>
<pre><code>git clone https://github.com/aggregateknowledge/postgresql-hll
cd postgresql-hll
export PATH=/home/digoal/gp/bin:$PATH
make clean
make
make install
</code></pre>
<p>确认hll.so正确的安装</p>
<pre><code>$ ll /home/digoal/gp/lib/postgresql/hll.so
-rwxr-xr-x 1 digoal digoal 116889 Aug 25 22:25 /home/digoal/gp/lib/postgresql/hll.so
</code></pre>
<p>因为postgres-hll是兼容9.0以上的create extension模式的，所以得看看控制文件</p>
<pre><code>cat hll.control   

comment = 'type for storing hyperloglog data'
default_version = '2.10.0'
module_pathname = '$libdir/hll'
</code></pre>
<p>然后需要修改sql文件</p>
<pre><code>vi hll--2.10.0.sql   

# MODULE_PATHNAME替换成$libdir/hll  

:%s/MODULE_PATHNAME/\$libdir\/hll/g
</code></pre>
<p>在需要使用hll的数据库执行hll--2.10.0.sql</p>
<pre><code>psql -f ./hll--2.10.0.sql
</code></pre>
<h2>测试</h2>
<p>测试的数据类型包括int2, int4, int8, text, bytea.<br />
分成20个组，一共100万数据。</p>
<pre><code>postgres=# create table test(groupid int, id int, info text, si int2, bi int8, f bytea );
CREATE TABLE
postgres=# insert into test select mod(id,20), id, md5(id::text), mod(id, 32760), id*2, md5(id::text)::bytea from generate_series(1,1000000) t(id);
INSERT 0 1000000
postgres=# create table hll_test(groupid int, id hll, info hll, si hll, bi hll, f hll);
CREATE TABLE
</code></pre>
<p>按分组聚合后，插入一张结果表</p>
<pre><code>postgres=# insert into hll_test select groupid, hll_add_agg(hll_hash_integer(id)), hll_add_agg(hll_hash_text(info)), hll_add_agg(hll_hash_smallint(si)), hll_add_agg(hll_hash_bigint(bi)), hll_add_agg(hll_hash_bytea(f)) from test group by groupid;
INSERT 0 20
</code></pre>
<p>查询每个分组的唯一值以及按阶段的唯一值。</p>
<p>每组，每个维度有多少唯一值</p>
<pre><code>postgres=# select groupid, hll_cardinality(id), hll_cardinality(si), hll_cardinality(bi), hll_cardinality(f), hll_cardinality(info) from hll_test order by 1;
 groupid | hll_cardinality  | hll_cardinality  | hll_cardinality  | hll_cardinality  | hll_cardinality
---------+------------------+------------------+------------------+------------------+------------------
       0 | 48978.0103680088 | 1647.82616880183 |  50061.344798351 | 50291.2509120929 | 50291.2509120929
       1 | 51741.8614936294 | 1612.36207917836 | 49284.9020691283 | 49566.9703531116 | 49566.9703531116
       2 | 50125.2622181007 | 1656.78898398222 | 48857.7015986003 | 50829.2972953538 | 50829.2972953538
       3 | 49432.4073263084 | 1638.90240740621 | 51253.0385002203 | 50091.9306033461 | 50091.9306033461
       4 | 48917.5103132368 | 1652.30267331635 | 50832.4721751387 | 50482.4523284526 | 50482.4523284526
       5 | 48869.3346787424 | 1686.19202905657 | 48969.8013300078 | 49222.6882488941 | 49222.6882488941
       6 | 51705.6275895237 | 1661.28514385613 | 49935.7562032158 |  50130.294716446 |  50130.294716446
       7 | 50394.3167326675 | 1679.36914656619 | 51657.2414098721 | 48798.3228462258 | 48798.3228462258
       8 |  48718.737519243 | 1668.04794581865 | 49049.1473914624 |  50781.921725461 |  50781.921725461
       9 | 50838.4114711808 | 1697.61425609909 | 49083.5959035864 | 51081.0313252514 | 51081.0313252514
      10 | 49902.2001005683 |   1627.802109229 |  50436.564830256 |  50081.537109579 |  50081.537109579
      11 |   48111.38122336 | 1634.45506581054 | 49123.4624391955 | 49922.9150526361 | 49922.9150526361
      12 | 48846.4713840826 |  1599.2197880897 | 49787.1437434036 | 50234.5603529724 | 50234.5603529724
      13 | 50941.2225741094 | 1679.36914656619 | 49016.4627290325 | 49298.6342587365 | 49298.6342587365
      14 | 49463.2045504603 | 1683.91520836626 | 48084.4839509038 | 48703.0775230689 | 48703.0775230689
      15 | 51273.4575447966 | 1652.30267331635 | 50053.6251645345 | 50288.1045937257 | 50288.1045937257
      16 | 48350.9891007992 | 1634.45506581054 | 49485.1660515215 | 49953.3728129477 | 49953.3728129477
      17 | 49278.5780270676 | 1661.28514385613 | 50607.8043111473 |  49688.123157263 |  49688.123157263
      18 | 48704.9059740248 | 1650.06319797018 | 52629.3748697963 |  49426.729576471 |  49426.729576471
      19 | 49326.5758972919 | 1634.45506581054 | 52245.5594837649 | 48453.7968119413 | 48453.7968119413
(20 rows)
</code></pre>
<p>所有数据范围，每个维度有多少唯一值</p>
<pre><code>postgres=# SELECT hll_cardinality(hll_union_agg(id)), hll_cardinality(hll_union_agg(si)), hll_cardinality(hll_union_agg(bi)), hll_cardinality(hll_union_agg(f)), hll_cardinality(hll_union_agg(info)) FROM hll_test;
 hll_cardinality  | hll_cardinality  | hll_cardinality  | hll_cardinality  | hll_cardinality
------------------+------------------+------------------+------------------+------------------
 981424.027645005 | 32006.8065955451 | 1008610.09767335 | 1027038.36191106 | 1027038.36191106
(1 row)
</code></pre>
<p>指定数据范围，每个维度又多少唯一值</p>
<pre><code>postgres=# SELECT hll_cardinality(hll_union_agg(id)), hll_cardinality(hll_union_agg(si)), hll_cardinality(hll_union_agg(bi)), hll_cardinality(hll_union_agg(f)), hll_cardinality(hll_union_agg(info)) FROM hll_test where groupid in (1,3,9);
 hll_cardinality  | hll_cardinality  | hll_cardinality  | hll_cardinality  | hll_cardinality
------------------+------------------+------------------+------------------+------------------
 149863.294108911 | 5227.10834581951 | 150151.868022589 | 150497.046827851 | 150497.046827851
(1 row)
</code></pre>
<h2>对比PostgreSQL结果一致</h2>
<p>结果略</p>
<h2>debug</h2>
<pre><code>postgres=# select hll_print(hll_add(hll_add_agg(hll_hash_bigint(t)),hll_hash_bigint(1))) from generate_series(3,10) g(t);
                                 hll_print
---------------------------------------------------------------------------
 EXPLICIT, 9 elements, nregs=2048, nbits=5, expthresh=-1(160), sparseon=1:
 0: -5469109305088493887
 1:    19144387141682250
 2:   489182038263080531
 3:  1140754268591781659
 4:  1310323436750511730
 5:  1960224177162737638
 6:  3522142095546486706
 7:  4145513480871534457
 8:  6574508035858270988
(1 row)
</code></pre>
<h2>调整精度</h2>
<p>调整当前会话精度</p>
<p>返回为老的值</p>
<pre><code>digoal=&gt; select * from hll_set_defaults(15,5,-1,1);
 o_log2m | o_regwidth | o_expthresh | o_sparseon
---------+------------+-------------+------------
      12 |          5 |          -1 |          1
(1 row)
Time: 0.330 ms
</code></pre>
<p>调整默认精度<br />
需要重新编译, 在hll.c中 :</p>
<pre><code>// Defaults if type modifier values are not specified.
//
#define DEFAULT_LOG2M           15
#define DEFAULT_REGWIDTH        5
#define DEFAULT_EXPTHRESH       -1
#define DEFAULT_SPARSEON        1  

static int32 g_default_log2m = DEFAULT_LOG2M;
static int32 g_default_regwidth = DEFAULT_REGWIDTH;
static int64 g_default_expthresh = DEFAULT_EXPTHRESH;
static int32 g_default_sparseon = DEFAULT_SPARSEON;
</code></pre>
<h2>优化</h2>
<p>我们前面讲了GP的聚合分两种使用，一种是全部收到MASTER节点执行，另一种是两阶段聚合。<br />
如果记录数少，其实没有必要使用两阶段聚合。</p>
<p>以hll_union_agg聚合为例</p>
<p>临时结果保存为stype: internal类型.</p>
<p>每次调用hll_union_trans函数，输入一条hll值以及临时结果internal，输出internal。</p>
<p>最后调用hll_pack，将internal转换为hll输出</p>
<pre><code>-- Union aggregate function, returns hll.
--
CREATE AGGREGATE hll_union_agg (hll) (
       SFUNC = hll_union_trans,
       STYPE = internal,
       FINALFUNC = hll_pack
);  

-- Union aggregate transition function, first arg internal data
-- structure, second arg is a packed multiset.
--
CREATE FUNCTION hll_union_trans(internal, hll)
     RETURNS internal
     AS '$libdir/hll'
     LANGUAGE C;  

-- Converts internal data structure into packed multiset.
--
CREATE FUNCTION hll_pack(internal)
     RETURNS hll
     AS '$libdir/hll'
     LANGUAGE C;
</code></pre>
<p>优化方法如下</p>
<p>在节点调用sfunc聚合，输入参数为(input_type数据 , 临时结果stype)，输出为stype</p>
<pre><code>sfunc( internal-state, next-data-values ) ---&gt; next-internal-state
</code></pre>
<p>segment第一阶段收集结果传输到master调用prefunc，输入(stype , stype)，得到的结果为stype</p>
<pre><code>prefunc( internal-state, internal-state ) ---&gt; next-internal-state
</code></pre>
<p>最后再将stype转换为聚合的输出类型即可(可选使用finalfunc)。</p>
<h2>hll_union_agg 优化例子</h2>
<pre><code>CREATE AGGREGATE gp_hll_union_agg (hll) (
  SFUNC = hll_union,
  prefunc = hll_union, -- 第二阶段函数
  STYPE = hll
);
</code></pre>
<h2>hll_add_agg 优化例子</h2>
<pre><code># select hll_empty();
  hll_empty
--------------
 \021\213\177
(1 row)

CREATE AGGREGATE gp_hll_add_agg (hll_hashval) (
  SFUNC = hll_add,
  STYPE = hll,
  prefunc = hll_union, -- 第二阶段函数
  initcond='\021\213\177'  -- 初始值
); </code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 12:01:24</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/greenplum/" title="Greenplum">Greenplum</a>, <a href="https://www.iamivan.net/tag/hll/" title="HLL">HLL</a>, <a href="https://www.iamivan.net/tag/hyperloglog/" title="HyperLogLog">HyperLogLog</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>hll 估值插件 在Greenplum中的使用 以及 分布式聚合函数优化思路的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5OoWRb.html" rel="bookmark">Greenplum中与Oracle类似的排序函数实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				create or replace function pgoramin ( is_val_1 varchar, is_val_2 varchar ) returns varchar as $$ begin if (oracompat.nlssort(is_val_1,'C') &gt;= oracompat.nlssort(is_val_2,'C')) then return is_val_2; else return is_val_1; end if; end $$ language plpgsql			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1jKwb.html" rel="bookmark">iOS开发中常见的项目文件与MVC结构优化思路解析&lowbar;IOS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				常见的项目文件介绍 一.项目文件结构示意图 二.文件介绍 1.products文件夹:主要用于mac电脑开发的可执行文件,ios开发用不到这个文件 2.frameworks文件夹主要用来放依赖的框架 3.test文件夹是用来做单元测试的 4.常用的文件夹(项目名称文件夹) (1)XXXinfo.plist文件(在该项目中为  01-常见文件-Info.plist) 1)简单说明 是配置文件,该文件对工程做一些运行期的配置,非常重要,不能删除. 在旧版本xcode创建的工程中,这个配置文件的名字就			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMN08mz.html" rel="bookmark">jQuery谷歌地图插件Maplace&lpar;图中附送如何攻击开源中国数据库&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery谷歌地图插件Maplace 图中附送如何攻击开源中国数据库..   var P1 = [ { lat: 45.468945, lon: 45.73684365, title: 'Title', html: 'Content', zoom: 10, animation: google.maps.Animation.DROP } ]; var LocsA = [ { lat: 45.9, lon: 10.9, title: 'Title A1', html: '&lt;h3&gt;Content			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2kDep.html" rel="bookmark">应用JD-Eclipse插件实现RFT中&period;class文件的反向编译</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 反编译是一个将目标代码转换成源代码的过程.而目标代码是一种用语言表示的代码 , 这种语言能通过实 机或虚拟机直接执行.文本所要介绍的 JD-Eclipse 是一款反编译的开源软件,它是应用于 Eclipse 开发平台的插件,它 可以帮助开发人员在调试程序的过程中显示所有的 Java 源代码,方便了开发人员的开发工作. JD-Eclipse 的安装 及配置 高级语言源程序经过编译变成可执行文件,反向编译就是其逆过程.但是由于反向编译的复杂性,通常不能 把可执行文件变成高级语言源代码,只能转换			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZON7Ob.html" rel="bookmark">JQuery boxy插件在IE中边角图片不显示问题的解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了JQuery boxy插件在IE中边角图片不显示问题的解决方法,十分的简单实用,有需要的小伙伴可以参考下. JQuery boxy插件很好用,但也会出现一些问题,比如弹出框的边角在IE中不能显示.本博文将来解决这个问题.将boxy插件引用到项目中后会有一个boxy.css文件和jquery.boxy.js文件.在boxy.css文件中有给弹出框设置四个角图片的样式,如下图: 不做任何修改在Chrome浏览器下没有问题,如下: 在网上查了一些资料,说将css文件中的图片路径给			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1Dkxjb.html" rel="bookmark">word   插件-如何编写word插件  让word中编辑好的文字上传到论坛</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如何编写word插件 让word中编辑好的文字上传到论坛 如题 知道论坛的接口代码 如何编写word插件 让word中编辑好的文字上传到论坛			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdWeZ1M.html" rel="bookmark">Yii框架引用插件和ckeditor中body与P标签去除的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Yii框架引用插件和ckeditor中body与P标签去除的方法.分享给大家供大家参考,具体如下: 在Yii中引用插件 注:插件和扩展不一样 1,源码放在project/ckeditor/* 2,在代码create,update中引用 Php代码 &lt;?php include_once &quot;/ckeditor/ckeditor.php&quot;; // Create a class instance. $CKEditor = new CKEditor(); // Path to			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX03Jyp.html" rel="bookmark">Windows平台下C&plus;&plus;插件系统实现的几个关键技术问题及其解决思路</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				根据我的实践,在Windows平台下设计并实现一个C++插件系统,需要解决几个关键技术问题.下面我谈谈需要解决的几个关键技术问题以及我想到的简单的解决思路.由于我主要专注于Windows平台C++程序的开发,这里假设以VS为编译环境,MFC界面库来说明. 1. 主程序和插件的关系问题      插件架构一般可以用下面的图来表示:   (注:此图来自李先静的博客文章:http://blog.csdn.net/absurd/archive/2006/07/04/877063.aspx ,略有修改,特			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0boLnVM.html" rel="bookmark">python中map、any、all函数用法分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了python中map.any.all函数用法,实例分析了map.any.all函数的相关使用技巧,具有一定参考借鉴价值,需要的朋友可以参考下 本文实例讲述了python中map.any.all函数用法.分享给大家供大家参考.具体分析如下: 最近想学python,就一直比较关注python,昨天在python吧看到有个帖子提问怎么在python中怎么判断密码是否符合规范,回帖中有很多用循环的,除此外还有一个没有用循环,代码非常简练,下面是代码: ? 1 2 3 4 5 6 d			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo66Bz.html" rel="bookmark" class="title">html-Dw cs6 要求点击按钮后在左下脚显示对应的mysql内容</a>
					<div>
						问题描述 Dw cs6 要求点击按钮后在左下脚显示对应的mysql内容 如上图:点击提交按钮后就在左下角那里显示我查询出来的内容,应该在哪里写代码,在用dm cs6做的,麻烦懂的人说下 数据库连接成功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxAWBp.html" rel="bookmark" class="title">Access使用查询--1&period;4&period;在查询中执行计算的注意事项</a>
					<div>
						4.在查询中执行计算的注意事项 如果要在字段中显示计算的结果,可以使用 Microsoft Access 所提供的预定义计算或自定义的计算.使用所谓&quot;总计&quot;的预定义计算,可计算出记 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd5KNz.html" rel="bookmark" class="title">Oracle Spatial数据加密问题研究</a>
					<div>
						oracle|加密|数据|问题 Oracle 9i2 特色功能:        1.返回值为自定义对象类型的函数.例如SDO_GEOMETRY数据类型.        2.可以用Java或C语言编写存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVvXnz.html" rel="bookmark" class="title">Photoshop实现三角形像素马赛克效果</a>
					<div>
						效果图 图00 第1步 准备一张作为banner背景的照片,下面我们以下图作为演示. 图01 第2步 复制两次背景层. 图02 第3步 使用自由变换工具(Ctrl + T 或选择主菜单&quot;编辑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1G7qz.html" rel="bookmark" class="title">提高SQL Server 2008可用性</a>
					<div>
						数据库镜像 &quot;Database Mirroring(数据库镜像)&quot;是一种可提高数据库可用性的技术.当主体数据库发生更改 时,这些更改也将自动应用到镜像数据库中.当主体服务器发生故障 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZaNVb.html" rel="bookmark" class="title">Win7系统扫描仪添加步骤全程图解</a>
					<div>
						  Win7扫描仪怎么添加 1.点击开始菜单,选择控制面板,选择设备和打印机 2.点击添加设备 3.选择要添加的打印机,如果添加失败,会自动弹出下图,选择控制面板-管理工具 4.点击服务,下拉并选择P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5odw6b.html" rel="bookmark" class="title">win7系统如何在局域网里共享文件</a>
					<div>
						  1.首先我们找到需要分享共享的文件夹,然后选中点击右键点击,就可以看到里面的属性的选项,点击属性打开. 2.在打开的属性窗口中我们看到&quot;共享&quot;选项点击打开设置页;   3.在来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOagXmM.html" rel="bookmark" class="title">重启U盘有技巧</a>
					<div>
						  在使用U盘的过程中,如果你&quot;安全删除硬件&quot;后没把U盘拔下,忽然又想起要继续使用U盘,你会怎么办?一般情况下都是拔下重插.有没有更简单的方法?有!但是先说个更复杂的: 在&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd1XOM.html" rel="bookmark" class="title">一体机网卡检测不到的处理思路</a>
					<div>
						  1. 首先确认是否有网卡 查看电脑周边接口有无RJ45网线接口.一般在后面.如下图所示: 2. 若电脑配置有网卡,查看&quot;设备管理器&quot;有无网卡设备 右击桌面小电脑图标,选择&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7B60M.html" rel="bookmark" class="title">Java多态的使用注意事项&lowbar;java</a>
					<div>
						Java多态是如何实现的?Java的多态和C++一样,是通过延时绑定(late binding)或者说运行时绑定(runtime binding)来实现的.当调用某一个对象引用的方法时,因为编译器并不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24jaZp.html" rel="bookmark" class="title">使用JavaScript获取Request中参数的值方法&lowbar;javascript技巧</a>
					<div>
						假设现在有一个URL,如下. http://www.jb51.net 如何通过JS访问到id和name里面的值呢,实现我们来分析一下思路. 先获取当前页面的URL,通过window.location. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrmPaM.html" rel="bookmark" class="title">IPV6中的分段报头问题？</a>
					<div>
						问题描述 1.举出一种情况,它会使一个包含片段报头的IPv6数据包中拆分报头的分片偏移量字段值为0,而片段报头的片段未完标志不置位.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEw6op.html" rel="bookmark" class="title">填充对象中的时间属性</a>
					<div>
						Java如何填充对象中的时间属性呢? 前提:不知道对象具体类型. 解决方法:使用反射   Java代码   /***       * 把对象中的列,类型为时间的都设置为当前时间       * @pa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6939b.html" rel="bookmark" class="title">contentresolver-Android&colon;ContentResolver的query中用count&lpar;&ast;&rpar;</a>
					<div>
						问题描述 Android:ContentResolver的query中用count(*) Uri uri=Uri.parse(&quot;content://sms/conversations&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmRGZz.html" rel="bookmark" class="title">亚洲最大苹果店北京开业 粉丝连夜排队</a>
					<div>
						王府井苹果店今日正式开业 新浪科技讯 10月20日上午消息.北京王府井Apple Store(苹果商店)今日9点正式开业,新店位于王府井商业街apm(原新东安商场),是目前亚洲最大的Apple Sto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXw8PlM.html" rel="bookmark" class="title">Nginx&plus;Tomcat动静分离及Nginx优化&lpar;企业案例&rpar;</a>
					<div>
						目的:nginx处理用户请求的静态页面,tomcat处理用户请求jsp页面,来实现动态分离,nginx处理静态页面效率远高于tomcat,这样一来就能更好的提高并发,处理性能. 准备软件: 下载jdk ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NDYnz.html" rel="bookmark" class="title">基于Libevent的HTTP Server</a>
					<div>
						简单的Http Server 使用Libevent内置的http相关接口,可以很容易的构建一个Http Server,一个简单的Http Server如下: #include &lt;event2/e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7GP4p.html" rel="bookmark" class="title">eclipse-Mac系统下Eclipse 安装pydev失败</a>
					<div>
						问题描述 Mac系统下Eclipse 安装pydev失败 出现这样的提示: Unable to create the selected preference page. org.python.pyde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NgJYM.html" rel="bookmark" class="title">Linux IP&lowbar;FORWARD introduce</a>
					<div>
						[原文] http://www.bubuko.com/infodetail_54855.html --Linux IP_FORWARD说明 -----------------------------2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7NXrz.html" rel="bookmark" class="title">Maven2&lowbar;pom文件</a>
					<div>
						在最开始如果你使用的时eclipse,那么你需要去安装一下maven的插件 插件路径:http://m2eclipse.sonatype.org/sites/m2e 安装指南:http://blog. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmlr9b.html" rel="bookmark" class="title">乱码request编码集问题</a>
					<div>
						问题描述 乱码request编码集问题 为什么我的request的编码集在servlet的本类其他方法中就失效了? 解决方案 request乱码问题解解request乱码问题request中文乱码问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RXGJz.html" rel="bookmark" class="title">Hadoop大象之旅001-安装VMware虚拟机</a>
					<div>
						Hadoop大象之旅001-安装VMware虚拟机                                                   老帅    VMware虚拟机允许一台真实的电脑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKyrEb.html" rel="bookmark" class="title">Go语言实现简单留言板的方法&lowbar;Golang</a>
					<div>
						本文实例讲述了Go语言实现简单留言板的方法.分享给大家供大家参考.具体实现方法如下: 复制代码 代码如下: package main import (     // &quot;fmt&quot;   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKVOjz.html" rel="bookmark" class="title">《深圳都市报》：360安全卫士原来是&OpenCurlyDoubleQuote;小偷&rdquo;？</a>
					<div>
						据每日经济新闻报道 2月25日,是奇虎360所有APP产品被苹果全面下架一个月的日子.知情人士向记者透露,国家版权局内部已讨论确定,360搜索引擎严重违反Robots国际规则,目前正在拟定相关处罚决定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBdXlz.html" rel="bookmark" class="title">Android makefile编写基础</a>
					<div>
						首先来看一个简单的Android makefile,这个是我上篇文章写的,重新摘出来: LOCAL_PATH:=$(call my-dir) include $(CLEAR_VARS) LOCAL_M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RWJqz.html" rel="bookmark" class="title">手机上网用户数达1675万人</a>
					<div>
						东南网7月10讯(本网记者 卢金福 实习生 漆锦辉)今日上午,福建省互联协会召开新闻发布会,正式对外发布了&lt;2011年度福建省互联网发展报告&gt;.报告显示,去年福建省互联网发展稳定,网民规模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5m45p.html" rel="bookmark" class="title">浦发银行一客户经理挪用1800万元赌博受审</a>
					<div>
						一年间以贴现名义先后从两公司骗取2450万元:直至案发前其银行卡仅剩10万元 [财新网] (综合媒体报道)浦发银行(600000.SH)一客户经理挪用1800余万元赌博,此案1月21日在上海市中级人民 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNn2nxM.html" rel="bookmark" class="title">System&period;Web&period;HttpException &lpar;0x80004005&rpar;</a>
					<div>
						问题描述 MVCAPI4.0,发布后System.Web.HttpException(0x80004005)老是抛这个异常,怎么处理啊!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmByElz.html" rel="bookmark" class="title">全国普通高校招生网上咨询周</a>
					<div>
						千龙网 本报讯(记者 李莉)记者从教育部获悉,&quot;2012年全国普通高校招生网上咨询周&quot;活动将于5月9日在&quot;阳光高考&quot;信息平台上正式启动.根据全国各省市考生填报志 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBqe1z.html" rel="bookmark" class="title">如何实现A、B、C、D、E、F&period;&period;&period;&period;&period;&period;Z；AA&period;&period;&period;&period;&period;&period;AZ等这样的顺序的自动编号规则。</a>
					<div>
						问题描述 我的情况是这样的:我想实现A.B.C.D.E.F......Z这样顺序的自动编号规则,例如:第一条记录代号:A.第二条记录代号:B第三条记录代号:C以此类推,当编到了Z后,再从AA.AB.A ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
